	/*
	 * create by uoon;
	 * email: mnx2012@gmail.com
	 */
	 
	(function(root) {
		
		var currentWindow = window, currentDocument = currentWindow.document;
		
		// Check everything.
		var isExists = function(obj) {
			return (obj != null && obj != undefined);
		};
		
		var notExists = function(obj) {
			return !isExists(obj);
		};
		
		var isArray = function(arr) {
			return (isExists(arr) && arr.constructor == Array);
		};
		
		var isDate = function(date) {
		
		};
		
		var isElement = function(ele) {
			return (isExists(ele) && ele.tagName && 1 == ele.nodeType);
		};

		var isFunction = function(func) {
			return (isExists(func) && func instanceof Function);	
		};
		
		var isJsObject = function(obj) {
			return (isExists(obj) && obj.constructor == Object);
		};
		
		var isNumber = function(num) {
			return (isExists(num) && num.constructor == Number);
		};
		
		var isObject = function(obj) {
			return (isExists(obj) && 'object' === typeof obj);
		};
		
		var isString = function(str) {
			return (isExists(str) && 'string' === typeof str);
		};
		
		var isBlank = function(str) {
			return (isString(str) && '' == str.replace(/^\s+|\s+$/g, ''));
		};
		
		var isRegExp = function(reg) {
			return (isExists(reg) && reg.constructor == RegExp);
		};
		
		var isTextNode = function(ele) {
			return (isExists(ele) && 3 == ele.nodeType);
		};
		
		var isIE6 = function() {
			return (/MSIE 6/).test(navigator.userAgent);
		};
		
		var isIE7 = function() {
			return (/MSIE 7/).test(navigator.userAgent);
		};
		
		var isIE8 = function() {
			return (/MSIE 8/).test(navigator.userAgent);
		};
		
		var isIE = function() {
			return (/MSIE/).test(navigator.userAgent);
		};
		
		var isOpera = function() {
			return (/Opera/).test(navigator.userAgent);
		};
		
		var isWebkit = function() {
			return (/Webkit/).test(navigator.userAgent);
		};
		
		var isFirefox = function() {
			return (/Firefox/).test(navigator.userAgent);
		};
		
		// store temporary data;
		var temporary = {
			method: {},
			number: {},
			object: {},
			variable: {}
		};
		
		var getNumber = (function () {
			var number = 0;
			return function() {
				return ++ number;
			}
		})();
		
		var storeFunction = function(id, src) {
			var id = isExists(id) ? id : getNumber();
			isFunction(src) && (temporary.method[id] = src);
			return id;
		};
		
		var callFunction = function(id) {
			var func = temporary.method[id];
			if (isFunction(func)) {
				return function() {
					func.apply(func, arguments);
				}
			}
		};
		
		var removeFunction = function(id) {
			if (isExists(temporary.method[id])) {
				delete temporary.method[id];
			}
		};
		
		var storeObject = function(id, src) {
			var id = isExists(id) ? id : getNumber();
			isObject(src) && (temporary.object[id] = src);
			return id;
		};
		
		var getObject = function(id) {
			return temporary.object[id];
		};
		
		var removeObject = function(id) {
			delete temporary.object[id];
		};
		
		var copy = function() {
			var arg = arguments;
			return {
				to: function(target) {
					target = isExists(target) ? target : {};
					for (var i = 0; i < arg.length; ++i) {
						var source = arg[i];
						for (var o in source) {
							if (!Object.prototype[o]) {
								if (isJsObject(source[o])) {
									isJsObject(target[o]) || (target[o] = {});
									copy(source[o]).to(target[o]);
								} else {
									// Override.
									target[o] = source[o];
								}
							}
						}
					}
					return target;
				}
			}
		};
		
		storeFunction('copy', copy);
		
		var selector = function(path, func) {
			var isId = /#((?:[\w\u00c0-\uFFFF_-]|\\.)+)/, eleNode = null;
			(path.replace(isId, '') != path) && (eleNode = currentDocument.getElementById(path.replace(isId, "$1")));
			if (eleNode) {
				if (isFunction(func)) {
					return func(extend.html(eleNode))
				}
				return extend.html(eleNode);
			}
			return null;
		};
		
		storeFunction('slector', selector);

		// for extend from user;
		var extension = {
			common: {},
			array: {},
			html: {},
			json: {},
			number: {},
			object: {},
			string: {},
			utility: {},
			xmlhttp: {},
			validate: {}
		};

		var extend = {
			
			common: function(data) {
			
				function cover(src) {
					if (notExists(src)) {
						return cover.source[0];
					} 
				};
				
				var visible = {
					source: [data],
					areNotEqual: function(expect, message) {
						if (this.source[0] == expect) {
							alert(message);
						}
						return this;
					},
					areEqual: function(expect, message) {
						if (this.source[0] != expect) {
							alert(message);
						}
						return this;
					},
					areNotSame: function(expect, message) {
						if (this.source[0] === expect) {
							alert(message);
						}
						return this;
					},
					areSame: function(expect, message) {
						if (this.source[0] !== expect) {
							alert(message);
						}
						return this;
					}
				};
				
				return copy(extension.common, visible).to(cover);
			},
			array: function(data) {
				
				function cover(src) {
					if (notExists(src)) {
						return  cover.source[0];
					} 
				};
				
				var visible = {
					source: [data]
				};
				
				return copy(extend.common(), extension.array, visible).to(cover);
			},
			html: function(data) {
				
				function cover(src) {
					if (notExists(src)) {
						return cover.source[0];
					} 
				};
				
				storeFunction(
					'updateSource', 
					function(obj) {
						isString(obj.source[0]) && (obj.source[0] = selector(obj.source[0])());
					}
				);
				
				var visible = {
					source: [data],
					add: function(option) {
						callFunction('updateSource')(this);
						var setting = {
								className: null,
								style: null,
								event: null,
								attribute: null,
								childNode: null
							},
							eleNode = this.source[0];
							
						copy(option).to(setting);

						isExists(setting.className) && extend.utility.addClassName(eleNode, setting.className);
						
						isExists(setting.style) && extend.utility.addStyle(eleNode, setting.style);
						
						isObject(setting.event) && extend.utility.addEvent(eleNode, setting.event);
						
						isExists(setting.childNode) && extend.utility.addChild(eleNode, setting.childNode);
						
						isObject(setting.attribute) && extend.utility.addAttr(eleNode, setting.attribute);
						
						return this;
					},
					addClass: function(className) {
						callFunction('updateSource')(this);
						extend.utility.addClass(this.source[0], className);
						return this;
					},
					addChilds: function() {
						callFunction('updateSource')(this);
						for (var i = 0; i < arguments.length; ++i) {
							var childNode = arguments[i];
							extend.utility.addChild(this.source[0], childNode);
						}
						return this;
					},
					addStyle: function(style) {
						callFunction('updateSource')(this);
						extend.utility.addStyle(this.source[0], style);
						return this;
					},
					addEvent: function(evt) {
						callFunction('updateSource')(this);
						extend.utility.addEvent(this.source[0], evt);
						return this;
					},
					addAttr: function(attribute) {
						callFunction('updateSource')(this);
						extend.utility.addAttr(this.source[0], attribute);
						return this;
					},
					setOpacity: function(value) {
						callFunction('updateSource')(this);
						(!isIE() && (this.source[0].style.opacity = value/100))  
							|| (this.source[0].style.filter = 'alpha(opacity = value)'.replace('value', value));
						return this;
					},
					getStyle: function(property) {
						callFunction('updateSource')(this);
						return extend.utility.getStyle(this.source[0], property);
					},
					getWidth: function() {
						callFunction('updateSource')(this);
						var eleNode = this.source[0],
							width = (eleNode.width) ? eleNode.width : eleNode.offsetWidth;
						return width;
					},
					getHeight: function() {
						callFunction('updateSource')(this);
						var eleNode = this.source[0],
							height = (eleNode.height) ? eleNode.height : eleNode.offsetWidth;
						return height;
					},
					getFirstChild: function() {
						callFunction('updateSource')(this);
						var theFirst = this.source[0].firstChild;
						while(theFirst && theFirst.nodeType != 1) {
							theFirst = theFirst.nextSibling;
						}
						return extend.html(theFirst);
					},
					getLastChild: function() {
						callFunction('updateSource')(this);
						var theLast = this.source[0].lastChild;
						while(theLast && theLast.nodeType != 1) {
							theLast = theLast.previousSibling;
						}
						return extend.html(theLast);
					}
				};
				
				return copy(extend.common(), extension.html, visible).to(cover);
			},
			number: function(data) {
				
				function cover(src) {
					if (notExists(src)) {
						return  cover.source[0];
					} 
				};

				var visible = {
					source: [data]
				};
				
				return copy(extend.common(), extension.number, visible).to(cover);
			},
			object: function(data) {
					
				function cover(src) {
					if (notExists(src)) {
						return cover.source[0];
					} 
				};
				
				var visible = {
					source: [data],
					appendTo: function(module) {
						if (module in extension) {
							for (var i in this.source[0]) {
								! (i in extension[module])
								&& (extension[module][i] = this.source[0][i]);
							}
						}
					},
					createModule: function(module) {
						currentWindow[root][module] = this.source[0];
					}
				};
				
				return copy(extend.common(), extension.object, visible).to(cover);
			},
			string: function(data) {
				
				function cover(src) {
					if (isString(src) || isNumber(src)) {
						cover.source.push(src);
					} else if (src == true) {
						return cover.source.join('');
					} else if (notExists(src)) {
						return selector(cover.source.join(''));
					} else if (isFunction(src)) {
						return selector(cover.source.join(''), src);
					} 
					return cover;
				};
				
				function updateSource(obj) {
					obj.source = [obj.source.join('')];
				};
				
				var visible = {
					source: [data],
					trim: function(status) {
						updateSource(this);
						return (status === true) ? this.source[0].replace(/^\s+|\s+$/g, '') : this;
					},
					toColor: function(status) {
						/*
							Convert text color to rgb value.
							example : foci('green').toColor(true);
							return: rgb(0, 128, 0);
						*/
						var colorName = this.source.join('');
						var table = extend.utility.createElement({
								tagName: 'table',
								style: {
									display: 'none',
									color: colorName
								}
							})(),
							value = null,
							match = null;
						table.bgColor = colorName;
						currentDocument.body.appendChild(table);
						value = isIE() ? table.bgColor : currentDocument.defaultView.getComputedStyle(table, null).getPropertyValue('color');
						currentDocument.body.removeChild(table);
						match = value.match(/^#(\w{2})(\w{2})(\w{2})/);
						value = !match ? value : "rgb(" + parseInt(match[1], 16) + ", " + parseInt(match[2], 16) + ", " + parseInt(match[3], 16) + ")";
						this.source = [value];
						return (status === true) ? this.source[0] : this;
					},
					urlEncode: function(status) {
						updateSource(this);
						return (status === true) ? encodeURIComponent(this.source[0]) : this;
					},
					urlDecode: function(status) {
						updateSource(this);
						return (status === true) ? decodeURIComponent(this.source[0]) : this;
					}
				};
				
				return copy(extend.html(), extend.common(), extension.string, visible).to(cover);
			},
			utility: {
				check: {
					isJsObject: isJsObject,
					isObject: isObject, 
					isArray: isArray,
					isNumber: isNumber,
					isElement: isElement,
					isTextNode: isTextNode,
					isFunction: isFunction,
					isBlank: isBlank,
					isString: isString,
					isFirefox: isFirefox,
					isIE: isIE,
					isIE6: isIE6,
					isIE7: isIE7,
					isIE8: isIE8,
					isOpera: isOpera,
					isWebkit: isWebkit,
					isExists: isExists,
					notExists: notExists
				},
				getNumber: getNumber,
				storeFunction: storeFunction,
				callFunction: callFunction,
				removeFunction: removeFunction,
				storeObject: storeObject,
				getObject: getObject,
				removeObject: removeObject,
				getEventSource: function(event) {
					return (event && event.target) ? extend.html(event.target) 
							: currentWindow.event ? extend.html(currentWindow.event.srcElement) : null;
				},
				getPageHeight: function() {
					return currentDocument.body.scrollHeight;
				},
				getPageWidth: function() {
					return currentDocument.body.scrollWidth;
				},
				getTime: function() {
					return new Date().getTime();
				},
				getX: function(src) {
					var doc = currentDocument;
					if (src && src.nodeName) {
						var x = 0;
						while (src) {
							x += src.offsetLeft;
							src = src.offsetParent;
						}
						return x;
					} else if (src.clientX !== undefined) {
						return src.clientX + doc.body.scrollLeft + doc.documentElement.scrollLeft;
					}
				},
				getY: function(src) {
					var doc = currentDocument;
					if (src && src.nodeName) {
						var y = 0;
						while (src) {
							y += src.offsetTop;
							src = src.offsetParent;
						}
						return y;
					} else if (src.clientY !== undefined) {
						return src.clientY + doc.body.scrollTop + doc.documentElement.scrollTop;
					}
				},
				getStyle: function(src, property) {
					var value, match, type = this.getStyleType(property);
					if (src.currentStyle && !isOpera()) { 
						if (type == 'opacity') {
							value = src.currentStyle['filter'];
							match = value.match(/(.*)opacity\s*=\s*(\w+)(.*)/i);
							value = match ? isNaN(parseFloat(match[2])) ? 100 : parseFloat(match[2]) : 100;
						} else { 
							value = src.currentStyle[property];
						}
					} else if (currentDocument.defaultView && currentDocument.defaultView.getComputedStyle) {
						property = property.replace(/[(A-Z)]/g, function(match){return '-' + match.toLowerCase()});
						value = currentDocument.defaultView.getComputedStyle(src, null).getPropertyValue(property);
						value = (type == 'opacity') ? 100 * value : value; 
					}
					
					switch (type) {
						case 'color': 
							return extend.string(value).toColor(true);
						case 'dimension': case 'position':
							return (value == 'auto' || value == 'normal') ? '0px' : value;
						default:
							return value;
					}
				},
				getStyleType: function(style) {
					switch (style) {
						case "backgroundColor": case "color":
							return "color";
						case "fontSize": case "height": case "letterSpacing": case "marginBottom": case "marginLeft": case "marginRight": case "marginTop": case "paddingBottom" : case "paddingLeft": case "paddingRight": case "paddingTop": case "width": case "wordSpacing":
							return "dimension";
						case "opacity":
							return "opacity";
						case "bottom": case "left": case "right": case "top":
							return "position";
						default:
							return "chaos";
					}
				},
				createId: function(src) {
					return extend.string(src || root)('-')(getNumber())('-')(new Date().getTime())(true);
				},
				createElement: function(config) {
					/*
						foci.createElement({
							id: foci.getNumber(),
							className: 'abc',
							style: {
								border: "1px solid red",
								height: "40px"
							}
						});
					*/
					var setting = {
						tagName: "div",
						id: null,
						className: null,
						innerHTML: null,
						// add.
						event: null,
						style: null,
						attribute: null
					};
					
					copy(config).to(setting);
					
					var newNode = currentDocument.createElement(setting.tagName);
					
					isExists(setting.id) && (newNode.id = setting.id);
					
					isExists(setting.className) && (newNode.className = setting.className);
					
					isExists(setting.innerHTML) && (newNode.innerHTML = setting.innerHTML);
										
					isObject(setting.event) && (extend.utility.addEvent(newNode, setting.event));
					
					isExists(setting.style) && (extend.utility.addStyle(newNode, setting.style));					
					
					isExists(setting.attribute) && (extend.utility.addAttr(newNode, setting.attribute));					
					
					return extend.html(newNode);
				},
				addAttr: function(eleNode, attribute) {
					for (var o in attribute) {
						if (!Object.prototype[o]) {
							eleNode.setAttribute(o.toString(), attribute[o]);
						}
					}
					return this;
				},
				addClass: function (eleNode, klass) {
					var oldClass = eleNode.className;
					eleNode.className = !isBlank(oldClass) ? oldClass += " " + klass : klass;
					return this;
				},
				addChild: function(eleNode, child) {
					if (isElement(child)) {
						eleNode.appendChild(child);
					} else if (isFunction(child)) {
						// only apply for this library;
						eleNode.appendChild(child());
					}
					return this;
				},
				addEvent: function(obj, evt) {
					for (var o in evt) {
						if (!Object.prototype[o]) {
							if (obj.addEventlistenerer) {
								obj.addEventlistenerer(o, evt[o], false);
							} else if (obj.attachEvent) {
								obj.attachEvent("on" + o, evt[o]);
							} else {
								obj["on" + o] = evt[o];
							}
						}
					}
					return this;
				},
				addStyle: function(eleNode, style) {
					if (isString(style)) {
						eleNode.setAttribute("style", style);
					} else if (isJsObject(style)) {
						var st = eleNode.style;
						for (var o in style) {
							if (o == 'float') {
								st['cssStyle'] = style[o];
								st['styleFloat'] = style[o];
							} else {
								st[o] = style[o];
							}
						}
					}
				},
				loadScript: function(path) {
					var newScript = currentDocument.createElement('script');
					newScript.setAttribute('src', path);
					newScript.setAttribute('type', 'text/javascript');
					currentDocument.getElementsByTagName('head')[0].appendChild(newScript);
				},
				viewStream: function() {
					var storeFunction = [],
						callee = arguments.callee.caller;
					while (callee) {
						storeFunction.unshift(callee.toString());
						callee = callee.arguments.callee.caller;
					}
					if (isExists(extend.common().viewSource)) {
						filter(storeFunction).viewSource();
					}
				},
				getWindow: function() {
					return currentWindow;
				},
				getDocument: function() {
					return currentWindow.document;
				},
				updateDocument: function(win) {
					currentWindow = win;
					currentDocument = win.document;
				},
				name: root
			}
		};
		
		var filter = function(data) {
			if (isArray(data)) {
				return extend.array(data);
			}
			if (isNumber(data)) {
				return extend.number(data);
			}
			if (isJsObject(data)) {
				return extend.object(data);
			}
			if (isString(data)) {
				return extend.string(data);
			}
			if (isElement(data)) {
				return extend.html(data);
			} 
			return extend.common(data);
		};
		
		!isString(root) && (root = 'foci');
		
		extension.common[root] = filter;
		
		currentWindow[root] = filter;
		
		copy(extension.utility, extend.utility).to(currentWindow[root]);
		
	})('foci');
	
	
	(function() {
		var transition = {
			0: function(x) {
				return x;
			},
			1: function(x) {
				return x*(2 - x);
			},
			2: function(x) {
				return Math.pow(x, 2);
			},
			3: function(x) {
				return Math.pow(x, 1/2);
			},
			// Elastic effect.
			4: function(x) {
				var t = 1 + 1 + 1/2 + 1/4, a = t*t/2;
				if (x < (2/t)) {
					return -a*x*x + t*1.5*x;
				} else if (x < (2.5/t)) {
					return a*x*x - t*2.25*x + 3.5;
				} else {
					return -a*x*x + t*2.625*x - 2.4375;
				}
			},
			// Bounce effect;
			5: function(x) {
				var t = 1 + 1 + 1/2 + 1/4, a = t*t, b = -2*t;
				// Parabol :  a x^2 + bx +  c = 1.
				if (x < (1/t)) {
					return a*x*x;
				} else if (x < (2/t)) {
					return a*x*x + b*1.5*x + 3;
				} else if (x < (2.5/t)) {
					return a*x*x + b*2.25*x + 6;
				} else {
					return a*x*x + b*2.625*x + 7.875;
				}
			},
			6: function(x) {
				return 0.5 - 0.5*Math.cos(x*Math.PI)
			},
			7: function(x) {
				return 0.5 - 0.5*Math.cos(x*10*Math.PI)
			},
			8: function(x) {
				return x + Math.sin(x*10*Math.PI)/5
			},
			9: function(x) {
				return x + 0.5*(x - 1)*Math.sin((x-1)*10*Math.PI)
			},
			10: function(x) {
				return Math.pow(x, 0.25) + (x/5)*Math.sin(x*20*Math.PI)
			},
			11: function(x) {
				return Math.pow(x, 0.25) + 0.5*(x-1)*Math.sin((x-1)*6*Math.PI)
			}
		};
		foci(transition).createModule('transition');
	})();
	
			
	(function(f) {
			
			function parse(type, value) {
				return {
					'value': type == 'color' ? f(value).toColor(true) : parseFloat(value),
					'unit': type == 'color' ? 'color' : value.toString().replace(/^[\d\s]|-[\d\s]/g, '')
				};
			}
			
			function split(source, target, divide, unit, transition) {
				var r, g, b, delta, range = [];
				if (unit == 'color') {
					source = source.match(/rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/i);
					target = target.match(/rgb\s*\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)/i);
					r = split(parseInt(source[1]), parseInt(target[1]), divide, '', transition);
					g = split(parseInt(source[2]), parseInt(target[2]), divide, '', transition);
					b = split(parseInt(source[3]), parseInt(target[3]), divide, '', transition);
					for (var i = 0; i <= divide; ++i) {
						range.push(string('rgb(')(parseInt(r[i]))(', ')(parseInt(g[i]))(', ')(parseInt(b[i]))(')')(true));			
					}
				} else { 
					delta = target - source;
					for (var i = 0; i <= divide; ++i) {
						range.push((source + transition(i / divide) * delta).toFixed(2) + unit);			
					}
				}
				return range;
			}
			
			function revolution(element, name, start, delay) {
				var proxy = element.albus[name],
					divide = proxy.value.length - 1;
				// Remove old register.
				if (element.albus['timer'][name]) {
					clearInterval(element.albus['timer'][name]);
				}
				var revolve = function() {
					var index = Math.ceil((new Date().getTime() - start)/delay);
					index = (index - divide > 0) ? divide : index;
					if (f.getStyleType(name) == "opacity") {
						foci(element).setOpacity(parseInt(proxy.value[index]));
					} else {
						element.style[name] = proxy.value[index];
					}
					if (index == divide) {
						clearInterval(element.albus['timer'][name]);
						delete element.albus['timer'][name];
						delete element.albus[name];
						if (element.albus['timer'].length == 0) {
							// Slowdown for IE.
							setTimeout(function(){element.albus.finish(element)}, 1);
						}
					} 
				}
				element.albus['timer'][name] = setInterval(revolve, delay); 
			}
			
			var visible = {
					transform: function(r) {
						f.callFunction('updateSource')(this);
						var ADN = this.source[0];
						
						var styleName = ["background", "backgroundColor", "backgroundImage", "backgroundPosition", "backgroundRepeat", "bottom", "clip", "color", "font", "fontSize", "height", "left", "letterSpacing", "lineHeight", "listStyleImage", "listStylePosition", "margin", "marginTop", "marginRight", "marginBottom", "marginLeft", "opacity", "padding", "paddingTop", "paddingRight", "paddingBottom", "paddingLeft", "right", "top", "width", "wordSpacing", "zIndex"];
						var setting = {
							start: r.start || function() {},
							end: r.end || function() {},
							delay: r.delay || 12,
							divide: r.divide || 100,
							transition: r.transition || function(x) {return x * (2 - x)}
						};
						// albus is older name of this libraly;
						ADN.albus = ADN.albus ? ADN.albus : {'timer': []};
						ADN.albus.finish = setting.end;
						var proxy, name, type, from, target, start = new Date().getTime();
						setting.start();
						for (var o in styleName) {
							name = styleName[o];
							if (f.check.isExists(r[name])) {
								type = f.getStyleType(name);
								if (type == "position" && f.getStyle(ADN, "position") != "absolute") {
									ADN.style.position = "relative";
								}
								proxy = ADN.albus[name] = {'value': null};
								if (f.check.isArray(r[name]) && r[name].length > 2) {
									proxy.value = r[name];
								} else if (f.check.isArray(r[name]) && r[name].length == 2) {
									from = parse(type, r[name][0]);
									target = parse(type, r[name][1]);
								} else {
									from = parse(type, f.getStyle(ADN, name));
									target = parse(type, r[name]);
								}	
								proxy.value = proxy.value ? proxy.value : split(from.value, target.value, setting.divide, target.unit, setting.transition);
								// Register new transform.
								revolution(ADN, name, start, setting.delay);
							}
						}
						
						//return this object;
						return this;
					}
			};
			
			f(visible).appendTo('html');
	})(foci);

	
	(function(f){
	
		var currentWindow = f.getWindow(),
			currentDocument = f.getDocument();
					
		function ignore(event) {
			var event = event || currentWindow.event;
			event.cancelBubble = true;
		}
		
		function ignoreDagDrop(group) {
			if (group && group.length) {
				for (var o = 0; o < group.length; ++o) {
					group[o].onmousedown = function(event) {
						var event = event || currentWindow.event;
						event.cancelBubble = true;
					}
				}
			}
		}
					
		var visiable = {
			setDragable: function(config) {
					f.callFunction('updateSource')(this);
					var ADN = this.source[0];
					ADN.store = {
						x: 0,
						y: 0,
						X: 0,
						Y: 0
					};
					ADN.event = {
						mouseDown: function() {},
						mouseMove: function() {},
						mouseUp: function() {}
					};
					ADN.run = {
						drag: config.onDrag || function() {},
						move: config.onMove || function() {},
						drop: config.onDrop || function() {}
					};
					ADN.drop = function() {
						ADN.store = null;
						ADN.event = null;
						ADN.run = null;
						ADN.drop = function() {};
						ADN.proxyEvent = null;
						ADN.onmousedown = ignoreDagDrop;
					};
					ADN.isIn = function(object) {
						if (!f.check.isElement(object)) {
							return false;
						}
						var Xmin = f.getX(object);
						var Xmax = Xmin + object.offsetWidth;
						var Ymin = f.getY(object);
						var Ymax = Ymin + object.offsetHeight;
						var X = ADN.store.X;
						var Y = ADN.store.Y;
						return (Xmin < X && X < Xmax && Ymin < Y && Y < Ymax) ? true : false;
					};
					ADN.assign = function(object) {
						var proxyEvent = object || ADN.cloneNode(true);
						proxyEvent.store = ADN.store;
						proxyEvent.event = ADN.event;
						proxyEvent.drop = ADN.drop;
						proxyEvent.isIn = ADN.isIn;
						proxyEvent.run = ADN.run;
						ADN.proxyEvent = proxyEvent;
						return ADN.proxyEvent;
					};
					ADN.event.mouseDown = function(event) {
						var event = event || currentWindow.event;
						ADN.run.drag.call({self: ADN, event: event});
						var Obj = ADN.proxyEvent || ADN;
						if (!(event.button == 2 || event.which == 3)) {
							var position = f.getStyle(Obj, 'position');
							Obj.style.position = (position != 'absolute') ? 'relative' : 'absolute';
							var left = f.getStyle(Obj, 'left');
							Obj.style.left = parseInt(left) ? left : '0px';
							var top = f.getStyle(Obj, 'top');
							console.log(top);
							Obj.style.top = parseInt(top) ? top : '0px';
							Obj.store.x = event.clientX;
							Obj.store.y = event.clientY;
							Obj.event.mouseMove = function(event) {
								var event = event || currentWindow.event;
								Obj.style.left = parseInt(Obj.style.left) + (event.clientX - Obj.store.x) + 'px';
								Obj.style.top = parseInt(Obj.style.top) + (event.clientY - Obj.store.y) + 'px';
								Obj.store.x = event.clientX;
								Obj.store.y = event.clientY;
								Obj.store.X = f.getX(event);
								Obj.store.Y = f.getY(event);
								Obj.run.move.call({self: Obj, event: event});
								return false;
							};
							Obj.event.mouseUp = function(event) {
								var event = event || currentWindow.event;
								document.onmousemove = null;
								document.onmouseup = null;
								Obj.onmouseup = null;
								Obj.event.mouseUp = null;
								Obj.event.mouseMove = null;
								Obj.run.drop.call({self: Obj, event: event});
								return false;
							};
							document.onmousemove = Obj.event.mouseMove;
							document.onmouseup = function(event) {
								var event = event || currentWindow.event;
								var S = f.getEventSource(event)();
								if (S != Obj) {
									document.onmousemove = null;
								}
								Obj.event.mouseUp(event);
							};
							Obj.onmouseup = Obj.event.mouseUp;
							return false;
						}
					};
					ADN.onmousedown = ADN.event.mouseDown;

					var aForm = ADN.getElementsByTagName("form");
					if (aForm && aForm.length) {
						ignoreDagDrop(aForm);
					} else {
						var aInput = ADN.getElementsByTagName("input");
						ignoreDagDrop(aInput);
						var aIframe = ADN.getElementsByTagName("iframe");
						ignoreDagDrop(aIframe);
						var aTextarea = ADN.getElementsByTagName("textarea");
						ignoreDagDrop(aTextarea);
					}
					return f(ADN);
				}
		};
		
		f(visiable).appendTo('html');
	})(foci);
	
	
	
	(function(f) {
		var holdId,
			root = f.name;
		
		var currentWindow = f.getWindow(),
			currentDocument = currentWindow.document;
					
		var visiable = {
			viewSource: function(state) {

				var src = (state == true) ? this.source[0] : this;
				/* Only show one console,
					if want to show more obeject,
						please add them in to an array
							then view this array source.
				*/
				var consoleId = holdId || f.createId(); 

				if (f.check.notExists(holdId)) {
					holdId = consoleId;
					var container = f.createElement({
						id: consoleId,
						event: {
							'mousedown': function(event) {
								var event = event || currentWindow.event;
								event.cancelBubble = true;
							}
						},
						style: {cursor: "default", top: "0px", position: "absolute", fontFamily: "Courier New", left: "0px", width: "100%", fontSize: "12px", height: "0px", zIndex: 101}
					})();
					currentDocument.body.appendChild(container);
				} else {
					// Remove content;
					var container = currentDocument.getElementById(consoleId);
					while (container.firstChild) {
						container.removeChild(container.firstChild);
					}
				}
				
				var info = f.createElement({
					style: {position: "relative", top: "0px", margin: "auto", borderTop: "1px solid #cccccc", width: "64%", color: "white", padding: "3px", background: "black", zIndex: 99}
				});
				var title = f.createElement({
					innerHTML: f("<div style='float:left;'>")
									("<span>[ + ]</span>")
								("<span style='cursor: pointer;' onclick='" + root + "(window).viewSource(true);'> window </span>")
								("<span style='cursor: pointer;' onclick='" + root + "(document).viewSource(true);'> / document </span>")
								("</div>")(true),
					style: {padding: "3px 0px 0px 0px", height: "20px"}
				});
				var button = f.createElement({
					style: {textAlign: "right", margin: "0px 0px 0px 200px", cursor: "move"}
				});
				var minimize = f.createElement({
					innerHTML: "--",
					tagName: 'span',
					style: {color: "red", fontWeight: "bold", cursor: "pointer", marginRight: "12px"},
					event: {
						'mousedown': function(event) {
							var event = event || currentWindow.event;
							event.cancelBubble = true;
							resizeConsole();
						}
					}
				});
				var close = f.createElement({
					innerHTML: '[X]',
					tagName: 'span',
					style: {color: 'red', fontWeight: 'bold', cursor: 'pointer'},
					event: {
						'mousedown': function(event) {
							var event = event || currentWindow.event;
							event.cancelBubble = true;
							removeConsole();
						}
					}
				});
				var dynamic = f.createElement({
					style: {position: 'relative', width: '100%'}
				});
				var textarea = f.createElement({
					tagName: 'textarea',
					style: {width: '99%', height: '43px', overflow: 'auto', margin: '2px auto'}
				});
				var active = f.createElement({
					innerHTML: 'eval',
					tagName: 'span',
					event: {
						'mousedown': function(event) {
							var event = event || currentWindow.event;
							event.cancelBubble = true;
							var value = textarea().value;
							value && eval(value);
						}
					},
					style: 'position: absolute; bottom: 3px; right: 2px;  padding: 0px 8px; color: black; border: 2px solid green;'
				});
				var content = f.createElement({
					style: {background: "#848484", border: "1px solid green", height: "300px", overflow: "auto", padding: "10px"},
					event: {
						'mousedown': function(event) {
							var event = event || currentWindow.event;
							event.cancelBubble = true;
						}
					}
				});

				f(container).addChilds(
					info.addChilds(
						title.addChilds(button.addChilds(minimize, close)),
						dynamic.addChilds(textarea, active),
						content
					)
				);
				
				// store child object;
				var childObject = [];
				
				function resizeConsole() {
					if (content().style.display != 'none') {
						content().style.display = 'none';
						minimize().innerHTML = '[]';
					} else {
						content().style.display = 'block';
						minimize().innerHTML = '--';
					}
				}
				
				var viewChild = f.storeFunction(
					'viewChild',
					function (clickElement, childId) {
						var parent = clickElement.parentNode.parentNode,
							target = f(parent).getLastChild();
						if (target.getFirstChild()()) {
							if (target().style.display != 'block') {
								target().style.display = 'block';
							} else {
								target().style.display = 'none';
							}
						} else {
							target().style.display = 'block';
							target().appendChild(discover(childObject[childId]));
						}
					}
				);
				
				function removeConsole() {
					if (holdId) {
						var console = currentDocument.getElementById(consoleId);
						currentDocument.body.removeChild(console);
						childObject = null;
						f.removeFunction(viewChild);
						holdId = null;
					}
				}
				
				function discover(o) {
					
					var node = f.createElement("div")();
					if (f.check.isString(o)) {
						node.innerHTML = f("<xmp>")(o)("</xmp>")(true);
					} else {
						var v = o && o.toString ? o.toString() : o, innerHTML = '';
						f.check.isArray(o) && (v = '[]');
						f.check.isObject(o) && (v = '{}');
						node.innerHTML = f("<div style='clear:left; line-height: 18px;'>")
												("<div style='color: #9b1a00; overflow: hidden; width: 246px; float: left;'>")
													("<span style='padding-left: 18px;'>source</span>")
												("</div>")
												("<div style='padding-left: 246px;'><xmp>")(v)("</xmp></div>")
											("</div>")(true);
						for (var p in o) {
							try {
								v = o[p] != null ? o[p] : '""';
							} catch(e) {
								v = "Can't Access !!!";
							}
							if ((/object/).test(typeof v)) {
								childObject.push(v);
								innerHTML = f("<div style='width: 246px; overflow: hidden; float: left;'>")
													("<span style='margin-right: 6px;'>[+]</span>")
													("<span style='color: #9b1a00; cursor: pointer;' onclick='")(root)('.callFunction("viewChild")(this, ')(childObject.length - 1)(")'>")(p)("</span>")
												("</div>")
												("<div style='margin-left: 246px;'><xmp>Object {...}</xmp></div>")
												("<div style='margin-left: 49px; display: none;'></div>")(true);
							} else {
								v = v.toString ? v.toString() : v;
								innerHTML = f("<div style='width: 246px; overflow: hidden; float: left;'>")
													("<span style='margin: 0px 12px 0px 8px;'>-</span>")
													("<span style='color: #9b1a00'>")(p)("</span>")
												("</div>")
												("<div style='margin-left: 246px;'><xmp>")(v)("</xmp></div>")(true);
							}
							
							node.appendChild(
								f.createElement({
									style: "clear:left; line-height: 18px;",
									innerHTML: innerHTML
								})()
							);
						}
					}
					return node;
				};
				
				f(container).setDragable({});
				content.add({childNode: discover(src)});
			}
		}
		f(visiable).appendTo('common');
	})(foci);
	