// supersync.js is copyright supersync.com
// Permission is granted to modify this source code at your own risk for use with 
// a licensed supersync application. More information available at supersync.com
// SuperSync is a personal music library organization tool.
var aboutHTML = "<div id='aboutbox'><img src='images/a0.png' width='781' height='360' id='aboutImg' onclick='aboutClick()'></div>";
var Dom = YAHOO.util.Dom;
var Event = YAHOO.util.Event;

var websiteUrl	= "";

var TableData 	= {};

var ABOUT	= 0;
var PLAYLISTS=1;
var GENRES	= 2;
var ARTISTS	= 3;
var ALBUMS	= 4;
var VIDEOS	= 5;
var SEARCH	= 6;
var ADMIN	= 7;

var aboutIndex = 0;

var categoryType = ["about", "playlist","genre","artist","album", "video", "search"];	// , "admin"
var categoryNames = ["About", "Playlists","Genres","Artists","Albums", "Videos", "Search"];	// , "Admin"
var MODE_PLAY= 0;
var MODE_DOWNLOAD = 1;
var MODE_PLAYLIST = 2;
var ModeType= ["Play","Download","Playlist"];
var categoryTable;
var trackTable;	// DataTable object to display tracks
var tabView;
var tabs = new Array(categoryNames.length);

var searchButton;

var category = ABOUT;	// Initial and current category. user may specify a tab using "tab=[al|ar|ge|vi|pl|se]"
var mode 	 = MODE_PLAY;
var argID = -1;		// Preload a playlist, album, genre, etc. 
var argStr = "";	// Holds name of artist, genre, etc, to play. 

var playList = new Array();	// array of int containing track ID's to be played
var playIndex = -1;			// int, current position in array. -1 for undefined, otherwise always between 0 and playlist.length-1
var player = null;
var useAlerts=true;

var layer0;
var layer1;
var layer2;
var libID = "";


var autoplay = false;

function $(id) { return document.getElementById(id); }

// TODO: Vertically align search icon/button with text input.
// TODO: Handle enter/return keystrokes as equivalent to hitting submit button if text len > 0 .

/**
 * enable/disable an YAHOO.util.Button object associated with a text field
 * @param e YAHOO.util.Event object on text field
 * @param oButton YAHOO.util.Button object
 */
var setButtonState = function(e, oButton) {
	var tar = Event.getTarget(e);
	var len = tar.value.length;
	oButton.set("disabled", (len === 0) );
};

function createSearch(id)
{
	var div = $(id);

	// if search_fieldset already exists, no need to create again
	if ($("search_fieldset")) {return;}

	var fs = document.createElement("fieldset");
	fs.setAttribute("legend","Search legend");
	fs.setAttribute("id","search_fieldset");
	//fs.id = "search_fieldset";

	var obj = document.createElement("input");
		obj.setAttribute("type","text");
		obj.setAttribute("id","textfield");
		obj.setAttribute("name","textfield");
		obj.setAttribute("class","input_box");
		obj.setAttribute("size","30");
		obj.setAttribute("maxlength","30");
		//obj.setAttribute("style","height:18px;vertical-align: top;");

	fs.appendChild(obj);

	var btn = document.createElement("input");
	
	btn.setAttribute("type","image");
	btn.setAttribute("src","images/search.gif");
	btn.setAttribute("onclick", "onSearchSubmit");
	btn.setAttribute("id","searchButton");
	

	fs.appendChild(btn);
	div.appendChild(fs);
	searchButton = new YAHOO.widget.Button("searchButton");
	searchButton.on("click", onSearchSubmit);

	// check search word
	var searchText = Dom.get("textfield");
	//searchButton.set("disabled", true);
	Event.on(searchText, "keyup", function(e) {
		if (e.keyCode == 13) {
			onSearchSubmit();
		}
		setButtonState(e, searchButton);
	});
	Event.on(searchText, "change", function(e) {setButtonState(e, searchButton);});
}

function createAbout(id)
{
	var div = $(id);

	// if about_fieldset already exists, no need to create again
	if ($("about_fieldset")) {return;}

	var fs = document.createElement("fieldset");
	fs.setAttribute("legend", "Search legend");
	fs.setAttribute("id", "about_fieldset");
	fs.innerHTML = aboutHTML;
	div.appendChild(fs);
}

/**
 *	This function is used to expand the browse category list
 *
 * 	@param	key: URL first parameter
 * 	@param	value: URL first parameter value
 *
*/
function expandCategoryTab(c)
{
	var u;
	var call;
	
	category = c;
	switch(c)
	{
		case SEARCH:
			createSearch(categoryType[category]+"_table");
			$('textfield').focus();
			break;
		case ABOUT:
			createAbout(categoryType[category]+"_table");
			break;
		case VIDEOS:
			timerLoading = setTimeout(showLoading, 500);
			u = "/web.cgi?list=Videos&xml=1";
			var div = $(categoryType[category]+"_table");
			div.innerHTML = "All Videos";
			call = YAHOO.util.Connect.asyncRequest('GET', u, categoryHandler);
			break;
		case ADMIN:
			window.location.href = websiteUrl+"/admin";
			break;
		
		default:
			timerLoading = setTimeout(showLoading, 500);
			u = "/web.cgi?list="+categoryNames[c]+"&xml=1&lib="+libID;
			call = YAHOO.util.Connect.asyncRequest('GET', u, categoryHandler);
			break;
	}
}

function buildString(str) {
	var store = [str];
	return function link(src) {
	  if (src !== null) {
		store.push(src);
		return link;
	  }
	  return store.join('');
	};
}

		
function doGetLibraryInfo(c)
{
	var getInfoHandler = {
		success: handleLibraryInfo,
		failure: ajaxFailure
	};

	var u = "/web.cgi?getinfo=1&xml=1&lib="+libID;
	call = YAHOO.util.Connect.asyncRequest('GET', u, getInfoHandler);
}

function doGetTrackInfo(c)
{
	var getInfoHandler = {
		success: handleTrackInfo,
		failure: hideTrackInfo
	};
	var u = "/web.cgi?trackinfo="+c+"&xml=1&lib="+libID;
	call = YAHOO.util.Connect.asyncRequest('GET', u, getInfoHandler);
}

function doGetTrackArtwork(c)
{
	var getInfoHandler = {
		success: handleTrackArt,
		failure: handleTrackArtFailed
	};
	var u = "/web.cgi?artwork="+c+"&width=200&height=200&lib="+libID;
	call = YAHOO.util.Connect.asyncRequest('GET', u, getInfoHandler);
}

function hideTrackInfo()
{
	if (true) return;
	$('trackTitle').style.visibility = 'hidden';
	$('trackAlbum').style.visibility = 'hidden';
	$('trackArtist').style.visibility = 'hidden';
	$('trackKind').style.visibility = 'hidden';
	$('perfect').style.visibility = 'visible';
}
function showTrackInfo()
{
	if (true) return;
	
	$('trackTitle').style.visibility = 'visible';
	$('trackAlbum').style.visibility = 'visible';
	$('trackArtist').style.visibility = 'visible';
	$('trackKind').style.visibility = 'visible';
	$('perfect').style.visibility = 'hidden';
	
}
function setTrackInfo(title, album, artist, kind)
{
	if (false)
	{
	$('trackTitle').innerHTML = title;
	$('trackAlbum').innerHTML = album;
	$('trackArtist').innerHTML = artist;
	$('trackKind').innerHTML = kind;
	} else
	{
		var html = "<p class='trackTitle'>"+title+"</p><p class='trackAlbum'>"+album+"</p><p class='trackArtist'>"+artist+"</p><p class='trackKind'>"+kind+"</p>";
		
	$('trackInfo').innerHTML = html;	
	}
	

}



function handleTrackInfo(t) {
try{
	var artist = getInfo(t, 'Artist');
	var album = getInfo(t, 'Album');
	var title = getInfo(t, 'Name');	
	var kind = getInfo(t, 'TrackInfo');
	var uid = getInfo(t, "uid");
	
	setTrackInfo(title, album, artist, kind);
	showTrackInfo();

	if (getInfo(t, "Artwork")=="true")
	{
		setArtImage("/web.cgi?artwork="+uid+"&width=200&height=200");
	} else
	{
		resetArtwork();
	}
	
}catch(e)
{
	alert(e);
}


}


function setArtImage(u)
{
	document.getElementById("artwork").src=u;
}

function resetArtwork()
{
	setArtImage("images/art.gif");
}


function getTrackTableWidth()
{
	return ""+(YAHOO.util.Dom.get('trackDiv').parentNode.offsetWidth-4)+"px";
}

function getTrackTableHeight()
{
	return ""+(YAHOO.util.Dom.get('trackDiv').parentNode.offsetHeight-28)+"px";
}

function getCategoryWidth()
{
	return ""+(YAHOO.util.Dom.get('catDiv').parentNode.offsetWidth-19)+"px";
}

function getCategoryHeight()
{
	return ""+(YAHOO.util.Dom.get('catDiv').parentNode.offsetHeight-70)+"px";
}

function resizeTrackTable()
{
	try {
		
		trackTable.set("height", getTrackTableHeight()); 
		trackTable.set("width", getTrackTableWidth()); 
		
		var catDiv = $('catDiv');
		var catParent = catDiv.parentNode;
		var w = YAHOO.util.Dom.getViewportWidth();
		// adjust width
		w-=234;
		
		catParent.style.width = w+"px";
		catDiv.style.width = w+"px";
		tabView.set("width", w+"px");
		
	} catch(err)
	{
		showErr(err);
	}
}



function playVideo(id, title, width, height)
{

	
	try  {
	var wpx = (width + 20) + "px",
		hpx = (height + 75) + "px",
		url = '/web.cgi?track=' + id;
	var posterURL = "poster.jpg?id="+id;
	stopPlayer();

	$('audio').style.visibility = 'hidden';
			
	var myPanel = new YAHOO.widget.Panel("myPanel", 
		{
			fixedcenter: true, 
			constraintoviewport: true, 
			underlay: "shadow", 
			close: true, 
			modal: true,
			width: wpx,	// "400px", 
			height: hpx, // "400px", 
			visible: true, 
			//effect:{effect:YAHOO.widget.ContainerEffect.FADE, duration: .5},
			draggable: true,
			zIndex:1500
		}
	);
	
	myPanel.setHeader(title);
	myPanel.setFooter('<a href="../'+url+'">Download</a>');
	myPanel.renderEvent.subscribe(
		function()
		{
			try {
				
			var html = '<video id="ios" controls autoplay preload width="'+width+'" height="'+height+'" poster="" >\
<source src="'+url+'"  /> \
</video>';

			
			
			myPanel.setBody(html);

			} catch(err2)
			{
				showErr("renderEvent:"+err2);
			}
			
		// showErr(html);
		}
	);

	myPanel.hideEvent.subscribe(
		function() {
			//closePopupLink();
			myPanel.setBody('');
			$('audio').style.visibility = 'visible';
		}
	);
	myPanel.render(document.body);
	} catch(err)
	{
		showErr("playVideo error: "+err);
	}
	
}

function showErr(msg)
{
	if (useAlerts) {alert(msg);}
	useAlerts=false;
}

function displayAlert(alertTitle, alertBody)
{
	try  {

		var alertPanel = new YAHOO.widget.Panel("alertPanel", 
			{
				fixedcenter: false, 
				constraintoviewport: true, 
				underlay: "shadow", 
				close: true, 
				modal: true,
				width: '400px', 
				height: '150px', 
				visible: true, 
				draggable: false,
				zIndex:1500
			}
		);
		
		alertPanel.setHeader(alertTitle);
		alertPanel.setBody(alertBody);
		alertPanel.render(document.body);
	} catch(err)
	{
		showErr("showAlert error: "+err);
	}
}


function createTrackTable(trackXML)
{
	var  videoFirstLoad = true;
	
	var playTracks = function(args)
	{
		// var curRecord = args.record;	

		var id = args.record.getData("id");
		var rs = trackTable.getRecordSet();//all records
		var len = rs.getLength();	// num records
		var pl = new Array(len);	// playlist holder
		var curIndex = -1;	// where to start playing
		// build playlist, using all records in table
		for (var x=0;x<len;x++)
		{
			var rec = trackTable.getRecord(x);
			var recordID = rec.getData("id");
			pl[x] = recordID;
			if (recordID==id)
			{
				curIndex = x;
				if ("true"== rec.getData("video") && videoFirstLoad) {
					videoFirstLoad = false;
					return;
				}
				
				if ("true"== rec.getData("video"))
				{
					var h = parseInt(rec.getData("height"),10);
					var w = parseInt(rec.getData("width"),10);
					var title = rec.getData("name");
					
					//Make sure title is not longer than width... 
					if (title.length > 32)
					{
						title = title.substr(0, 32) + '...';
					}
					playVideo(id, title, w, h);
					return;
				}
				
			}
		}
		playList = pl;
		playIndex=curIndex;	// start playing here.
		playtrack(playList[playIndex]);


	};
	var r=false;

	var trackColumnDefs = [
		//	{key:"id", sortable:true,resizeable:true},
		{key:"name", label:"Title", sortable:true,resizeable:r,minWidth:300},
		{key:"artist", label:"Artist", sortable:true,resizeable:r,minWidth:250},
		{key:"album", label:"Album", sortable:true,resizeable:r,minWidth:250},
		{key:"num", label:"Track", sortable:true,resizeable:r,minWidth:70},
		{key:"time", label:"Time", sortable:true,resizeable:r,minWidth:40},
		{key:"kind", label:"Kind", sortable:true,resizeable:r,minWidth:40}	
	];
	var trackDataSource;

	if (trackXML!==null)
	{
		trackDataSource 				= new YAHOO.util.DataSource(trackXML);
		trackDataSource.responseType 	= YAHOO.util.DataSource.TYPE_XML;
	} else
	{
		trackData = [ {id:-1, Name:"", artist:"", album:"", num:"", time:""}];
		trackDataSource 				= new YAHOO.util.DataSource(trackData);
		trackDataSource.responseType 	= YAHOO.util.DataSource.TYPE_JSARRAY;
	}

	trackDataSource.responseSchema 	= { resultNode: "track", fields:["id", "name","artist","album","num","time","video", "width", "height", "kind", "xcode"] };

	try {
		trackTable = new YAHOO.widget.DataTable("trackDiv", trackColumnDefs, trackDataSource, {width:getTrackTableWidth(),height:getTrackTableHeight(), scrollable:true});
	} catch(err)
	{
		showErr("error creating track table "+ err);
	}
	
	// select first row, before adding listeners..
	// trackTable.selectRow(trackTable.getTrEl(0));
	
	// Subscribe to events for row selection
	trackTable.subscribe("rowMouseoverEvent", trackTable.onEventHighlightRow);
	trackTable.subscribe("rowMouseoutEvent", trackTable.onEventUnhighlightRow);
	trackTable.subscribe("rowClickEvent", trackTable.onEventSelectRow);
	trackTable.subscribe("rowSelectEvent", playTracks);
	
	
	if (autoplay)
	{
		autoplay=false;
		trackTable.selectRow(trackTable.getTrEl(0));
	}
	
	
}


function successTrack(t) {
	hideLoading();
	createTrackTable(t.responseXML);
}

var trackHandler = {
	success: successTrack,
	failure: ajaxFailure
};

function getInfo(t, id) 
{
	try{
		return t.responseXML.getElementsByTagName(id)[0].childNodes[0].nodeValue;
	} catch(err)
	{
		// alert(err+" for "+id);
		return "";
	}
}

function handleLibraryInfo(t) {

	var div = $('infoDiv');
	var vers = getInfo(t, 'Version');
	var tracks = getInfo(t, 'Tracks');
	var name = getInfo(t, 'Name');	
	var hasAdmin = getInfo(t, "Admin");

	if (hasAdmin)
	{	
		var adminTab = new YAHOO.widget.Tab({label: "Admin",
		content: '<div id=admin_table"></div>', active: false});
		tabView.addTab(adminTab);
	}

	
	div.innerHTML = 
	"<center><BR><P><B>"+name+"</B></P>"+
	// "<div><font size=-3><a class='linkGen' href='javascript:void(0);' onclick='getLink(event);'>Link</a></font></div>" + 
	"<P><font size=-3><a href='http://supersync.com/' target='_blank'>SuperSync</a> version "+vers+"</font></P></center>";

	var warning = getInfo(t, "warning");
	if ("true"== warning)
	{
		displayAlert(getInfo(t, "warn-title"), getInfo(t, "warn-body"));
	}
}

function getLink(e) {
	var x = YAHOO.util.Event.getPageX(e);
	var y = YAHOO.util.Event.getPageY(e);
	var popupLayout = $('popupLayout');
	$('holdLink').focus();
	popupLayout.style.zIndex = 9999;
	popupLayout.style.top = y + "px";
	popupLayout.style.left = x + "px";
	popupLayout.style.display = "block";
}

function closePopupLink() {
	$('popupLayout').style.display = "none";
}

/**
 *	This function is used to load the track list
 */
var loading = null, timerLoading;
function showLoading() {
	if (!loading)
	{
		loading = new YAHOO.widget.Panel("loading", 
			{
				fixedcenter: true, 
				constraintoviewport: true, 
				underlay: "none", 
				close: false, 
				modal: true,
				width: "128px",	// "400px", 
				//height: "135px", // "400px", 
				visible: true, 
				draggable: false,
				zIndex:1500
			}
		);
	}
	
	$('loading').style.display = "block";
	loading.render(document.body);
	loading.show();
}
function hideLoading() {
	timerLoading && clearTimeout(timerLoading);
	loading && loading.hide();
}

function loadTrackList(key, value)
{	
	var u = "/web.cgi?" + key+"=" + value + '&xml=1';
	
	timerLoading = setTimeout(showLoading, 500);
	var name = getNameViaId(value);
	$('holdLink').value = websiteUrl + "/?tab=" + key + "&name=" + escape(name) + "&autoplay=false";
	YAHOO.util.Connect.asyncRequest('GET', u, trackHandler);
}

function aboutClick()
{
	aboutIndex = (++aboutIndex%3);
	document.getElementById("aboutImg").src="images/a"+aboutIndex+".png";
}

function changeTab(ev)
{
	expandCategoryTab(tabView.get('activeIndex'));
}

// Create the main category tab with Playlists, artists, etc. tab items
function createCategoryTab()
{
 	tabView = new YAHOO.widget.TabView();
	for (x=0;x<categoryType.length;x++)
	{
		// create a simple tab with the content set to a div with id set to category
		// name, such as artist_table, search_table, etc.
		tabs[x] = new YAHOO.widget.Tab({label: categoryNames[x],
		content: '<div id="'+categoryType[x]+'_table"></div>',
		active: x==category});
		tabView.addTab(tabs[x]);
	}

	// respond to tab events by changing the category to the new value.
	tabView.on('activeTabChange', function changeTab(ev) {	expandCategoryTab(tabView.get('activeIndex')); });
	tabView.appendTo('catDiv');
}

function createPlayerPanel()
{
	createHTML5PlayerPanel(0);	
}



function createHTML5PlayerPanel(id)
{
	var html= '<audio class="audio" controls preload autoplay width=204 height=40>\n';
	if (id>=0)
	{
		html+='<source src="/web.cgi?track='+id+'&typ=mp3" type="audio/mp3">' + '<source src="/web.cgi?track='+id+'&typ=ogg" type="audio/ogg">';
	}
	
	html+='</audio>';

	var div = $('audio');
	div.innerHTML = html;
}


// Create a category table.	 
function createCategoryTable(id, xmlData)
{
	var onRowSelectEvent = function(args)
	{
		var record = args.record;
		var newID = record.getData("id");
		loadTrackList(categoryType[category], newID);
	};
	
	// TODO: Make column expand to full size of table.
	var nameDefs = [{key:"name", sortable:true,resizeable:false,label:categoryNames[category]}];
	var categoryDataSource 					= new YAHOO.util.DataSource(xmlData);
	categoryDataSource.responseType 	= YAHOO.util.DataSource.TYPE_XML;
	categoryDataSource.responseSchema 	= { resultNode: categoryType[category],fields: ["name", "id"]};

	var th = getCategoryHeight();
	var tw = getCategoryWidth();

	try {

		categoryTable = new YAHOO.widget.DataTable(id, nameDefs, categoryDataSource, {scrollable:true, height:th, width:tw});
			// Subscribe to events for row selection
		categoryTable.subscribe("rowMouseoverEvent", categoryTable.onEventHighlightRow);
		categoryTable.subscribe("rowMouseoutEvent", categoryTable.onEventUnhighlightRow);
		categoryTable.subscribe("rowClickEvent", categoryTable.onEventSelectRow);
		
		// categoryTable.set('strings.emptyMessage',"Your custom message string");
		
		

		
		// Add our row select listener.
		categoryTable.subscribe("rowSelectEvent", onRowSelectEvent);
		// Programmatically bring focus to the instance so arrow selection works immediately
		categoryTable.focus();
		
		if (argID!=-1 || argStr.length>0)
		{
			// find table row with id == argID
			// or the table with name==argStr
			var index = null;
			if (jXML && jXML[argStr])
			{
				index = parseInt(jXML[argStr].index,10);
			}
			
			if (index != null && (index >0)) 
			{
				var rowSelected = categoryTable.getTrEl(index-1);
				// select it (scrolling to it if needed?)
				categoryTable.selectRow(rowSelected);
				// should call loadTrackList if hasn't already.
				rowSelected.scrollIntoView(true);
				// data will be added.. second call to loadTrackList should be removed from createLayout() func
				argID=-1;	// only do this once.
				argStr="";
				autoplay = (getURLParam("autoplay") == "true") ? true : false;
			}
		}
		
		
	} catch(err)
	{
		showErr("error creating category table "+ err.message);
	}
}


function onSearchSubmit(p_oEvent)
{
	var searchValue	= $('textfield').value;
	var u = "/web.cgi?search="+searchValue+"&xml=1";
	call = YAHOO.util.Connect.asyncRequest('GET', u, trackHandler);
}

function getPlayer()
{
	if (!$('audio')) showErr("No audio div found");
	
	return true;
}

function _loadtrack(id) {
	renderPlayer(id, false); 
}

function playtrack(id) 
{
	renderPlayer(id, true);
}

function endsWith(str, suffix) {
	return str.toLowerCase().indexOf(suffix.toLowerCase(),
			str.length - suffix.length) !== -1;
}

function nextTrackCallback()
{
	window.nextTrack();
}


function renderPlayer(id, state) 
{
try {
	if (id!=-1)
	{
		
		// getPlayer();
		state = (state === true) ? "true" : "false";
		var url = "/web.cgi?track="+id+"&lib="+libID;
		doGetTrackInfo(id);		
		createHTML5PlayerPanel(id);
	
	}
	
} catch(e) { 
			showErr("RenderPlayer: "+e); 
			}	
	
	
}


function stopPlayer() 
{
	createHTML5PlayerPanel(0);
}


function prevTrack()
{
	if (playList===null || playList.length===0) {
		return;
	}
	playIndex--;
	if (playIndex<0) {
		playIndex=0;
	}
	playtrack(playList[playIndex]);
}


function nextTrack()
{
	if (playList===null || playList.length===0) {
		return;
	}

	playIndex++;
	if (playIndex >= playList.length-1)
	{
		stopPlayer();
	} else
	{
		if (playList[playIndex]!=-1) {
			playtrack(playList[playIndex]);
		}
	}
}


function createLayer0()
{
	var def = {
	units: [{ position: 'center', resize: false, body: 'layer0Div', gutter: '2px' }]
	};

	layer0 = new YAHOO.widget.Layout(def);
	layer0.on('render', createLayer1);
	layer0.render();
}


function createLayer1()
{
	var mainLayoutDef = {
	// minWidth: 1000,
	minHeight: 600,
	units: [
	{ position: 'top', resize: true, scroll: false, height: 420 },
	{ position: 'center', resize: false, body: 'trackDiv', gutter: '5px' }
	] };
	if (layer0!=null)
		layer1 = new YAHOO.widget.Layout(layer0.getUnitByPosition('center').get('wrap'), mainLayoutDef);
	else
		layer1 = new YAHOO.widget.Layout(mainLayoutDef);
	
	layer1.on('render', createLayer2);
	layer1.on('render', createTrackTable);
	layer1.render();
	layer1.on('resize', resizeTrackTable);
}

function createLayer2()
{
	var row1Def = {
	units: [
	{ position: 'left', width: 220, resize: false, body: 'iconDiv', gutter: '5px', scroll: false, maxWidth: 220 },
	{ position: 'center', resize: true, body: 'catDiv', gutter: '5px'}
	]
	};
	
	var el = layer1.getUnitByPosition('top').get('wrap');
	layout2 = new YAHOO.widget.Layout(el, row1Def);
	layout2.on('render', function()
			{
				YAHOO.util.Dom.setStyle($('iconDiv').parentNode, 'background-color', "#FFFFFF");
				createPlayerPanel();
				createCategoryTab();
			});

	layout2.render();
}

function getURLParam(strParamName){
  var strReturn = "";
  var strHref = window.location.href;
  if ( strHref.indexOf("?") > -1 ){
	var strQueryString = strHref.substr(strHref.indexOf("?")).toLowerCase();
	var aQueryString = strQueryString.split("&");
	for ( var iParam = 0; iParam < aQueryString.length; iParam++ ){
	  if (aQueryString[iParam].indexOf(strParamName.toLowerCase() + "=") > -1 ){
		var aParam = aQueryString[iParam].split("=");
		strReturn = aParam[1];
		break;
	  }
	}
  }
  return unescape(strReturn);
}


function parseArguments()
{
	var whichTab = getURLParam("tab").toLowerCase();
	if (whichTab.length >=2)
	{
		whichTab = whichTab.substr(0,2);
		for (x=0;x<tabs.length;x++)
		{
			if (categoryType[x].substr(0,2) == (whichTab))
			{
				category=x;	// set start tab. 
				break;
			}
		}
	}
	
	var whichID = getURLParam("id");
	if (whichID.length>0)
		argID = parseInt(whichID,10);
		
	argStr = getURLParam("name");
	
}


function createLayout()
{
	parseArguments();
	createLayer1();
}



/**
 *	This function to show the error text message on ajax response
*/
function ajaxFailure( t ) 
{
	hideLoading();
	showErr('There was an error:' + t.statusText+". Try reloading page.");
}

/**
 *	Ajax call callback function
*/
var categoryHandler = {
	success: categorySuccess,
	failure: ajaxFailure
};


/**
 *	This function is used on sucessfully ajax data loaded.
*/
function getTextContent(node) {
	if (!node) {return ""}
	if (node.text) {return node.text}
	else if (node.textContent) {return node.textContent}
	else {return ""}
}

function parseXML(doc) {
	var jXML = {};
	var XML = doc.documentElement;
	var index = 0;
	if (XML) {
		var KNodes = XML.getElementsByTagName("id");
		for (var o = 0; o < KNodes.length;  ++ o) {
			var id = getTextContent(KNodes[o].childNodes[0]);
			var parentNode = KNodes[o].parentNode;
			var nodeName = parentNode.getElementsByTagName("name")[0];
			var name = getTextContent(nodeName.childNodes[0]);
			if (name) 
			{
				index++;
				jXML[name.toLowerCase()] = {'id': id, 'index' : index};
			}
		}
	}
	return jXML;
}


function getNameViaId(id) {
	for(var i in jXML) {
		if (jXML[i].id == id) {
			return i;
		}
	}
	return "";
}

var jXML = null;


function categorySuccess(t) {
	var id = categoryType[category]+"_table";
	hideLoading();

	if (categoryType[category] == "video") {
		createTrackTable(t.responseXML);
	} else {
	
		try {
			jXML =	jXML = parseXML(t.responseXML);
			jXML && jXML[argStr] && (argID = parseInt(jXML[argStr].id,10));

			createCategoryTable(id, t.responseXML);
		} catch(e)
		{
			showErr("categorySuccess failure: "+e);
		}
	}
}



function doOnLoad()
{
	websiteUrl = "http://"+location.hostname+":"+location.port;	
	expandCategoryTab(category);
	doGetLibraryInfo();
}

/**
 *	This function is default load on window load.
*/
window.onload = doOnLoad;

Event.onDOMReady(createLayout);
