#!/bin/sh
if [ -f "/var/run/supersync.pid" ]
then
        PID=`cat /var/run/supersync.pid`
QUIT_URL="https://localhost:5360/admin?cmd=quit&pid=${PID}"
        echo "Stopping SuperSync on PID: ${PID}"
        echo "$QUIT_URL"


        wget --no-check-certificate -q "$QUIT_URL" -O /dev/null
        echo "Waiting for normal SuperSync shutdown..."

        SECS=0

        while [ ${SECS} -le 30 ]
        do
                if [ ! -f /var/run/supersync.pid ]
                then
                        echo "SuperSync Service Stopped"
                        exit 0;
                fi
                SECS=$((SECS+1))
                sleep 1
        done

        echo "SuperSync not stopped. Killing."


if [ -f "/var/run/supersync.pid" ]
then
PID=`cat /var/run/supersync.pid`
echo "Killing PID: ${PID}"
kill -9 ${PID}
sleep 2
echo "Killed. Removing pid file."
rm -f /var/run/supersync.pid
fi




else
        echo "SuperSync not running"
fi

exit 0

